#ifndef DEVICEUTIL_H_
#define DEVICEUTIL_H_

#include <stdio.h>
#include <stdlib.h>
#include <cuda_runtime.h>

#define ASSERT_CUDA(s...)						\
  {									\
    cudaError_t error;							\
    s;									\
    if((error = cudaGetLastError()) != cudaSuccess) {			\
      printf("Failed to assert '%s' in %s on line %d\n\nCuda Error:\n%s\n\n", #s, __FILE__, __LINE__, cudaGetErrorString(error)); \
    }									\
  }


#endif
