#include "cuda_runtime_api.h"
#include "assert.h"
#include "DeviceUtil.hpp"

#include "lfg_kernel.cu"

__global__ void lfg_init_rn_g(unsigned int * gen)
{
  	unsigned int * cgen = gen;

  	if(init_rng(cgen))
  	{
  		return;
  	}

  	return;
}

void write_rngen(unsigned int * temp)
{
	int i;
	FILE * fp = fopen("rngen.log", "w");
	assert(fp); 

	fprintf(fp, "r1:\n");		
	for(i = 0; i < 1280; i++)
	{
		fprintf(fp, "r1[%d]: %d\n", i, temp[i]);
	}
	
	fclose(fp);

	return;
}

int main ()
{
	unsigned int * p_d_gen = NULL, * p_h_gen = NULL;

	p_h_gen = (unsigned int *)malloc(sizeof(unsigned int) * 1280);
	assert(p_h_gen);

	ASSERT_CUDA(cudaMalloc((void**)&p_d_gen, sizeof(unsigned int) * 1280));
	ASSERT_CUDA(cudaMemset(p_d_gen, 0, sizeof(unsigned int) * 1280));

	ASSERT_CUDA(lfg_init_rn_g<<<1, 1>>>(p_d_gen));

	ASSERT_CUDA(cudaThreadSynchronize());
	ASSERT_CUDA(cudaMemcpy(p_h_gen, p_d_gen, sizeof(unsigned int) * 1280, cudaMemcpyDeviceToHost)); 

	write_rngen(p_h_gen);

	ASSERT_CUDA(cudaFree(p_d_gen));

	free(p_h_gen);

	return 0;
}

