#ifndef _SPRNG_LFG_KERNEL_CU_
#define _SPRNG_LFG_KERNEL_CU_

#define INT_MOD_MASK 0xffffffff
#define INT_MASK ((unsigned int)INT_MOD_MASK>>1)
#define GS0 0x372f05ac

static __device__ int bitcnt(int x)
{
  	unsigned int i = 0, y;

  	for (y=(unsigned int)x; y; y &= (y-1))
  	{	 
		i++;
  	}

  	return(i);
}

static __device__ void advance_reg(int *reg_fill)
{
  	unsigned int mask = 0x1b;

  	int i,new_fill[2];
  	unsigned int temp = 0;

  	new_fill[1] = new_fill[0] = 0;

  	for (i = 27; i >= 0; i--) 
  	{
    		new_fill[0] = (new_fill[0] << 1) | (1 & bitcnt(reg_fill[0] & temp));
    		new_fill[1] = (new_fill[1] << 1) | (1 & bitcnt(reg_fill[1] & temp));
    		temp >>= 1;
  	}
	
	for (i = 28; i < 32; i++) 
  	{
    		temp = bitcnt(reg_fill[0] & (mask << i));
    		temp ^= bitcnt(reg_fill[1] & (mask >> (32 - i)));
    		new_fill[0] |= (1 & temp) << i;
    		new_fill[1] |= (1 & temp) << i;
  	}
  	reg_fill[0] = new_fill[0];
  	reg_fill[1] = new_fill[1];

	return;
}

static __device__ int init_rng(unsigned int * r)
{
  	int i, temp[2];
  	int seed = 985456376;
	unsigned int length = 1279;
	
	seed &= 0x7fffffff;
	seed &= GS0;

  	temp[1] = temp[0] = 1 ^ seed;

  	if (!temp[0])
  	{
    		temp[0] = GS0;
  	}

  	advance_reg(temp);

  	for (i = 1; i < length - 1; i++) 
  	{
    		r[i] = temp[0]; 
  	}
  
  	for (i = 1; i < 4; i++)
  	{
    		r[i] |= 1;
  	}

	return(0);
}

#endif
